﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	
	Private mListViews() As ListView
	Private mScrollBars() As JavaObject
	Private mClicked As ListView
End Sub

'Initializes the object.
Public Sub Initialize(ListViews() As ListView,Orient As String)
	Dim mListViews(ListViews.Length) As ListView
	Dim mScrollBars(ListViews.Length) As JavaObject
	For i = 0 To ListViews.Length - 1
		mListViews(i) = ListViews(i)
		Dim HideScrollBar As Boolean
		'Only show the scroll bar for the first (Master) ListView in the list
		If i <> 0 Then HideScrollBar = True
		mScrollBars(i) = SetScrollListener(mListViews(i),Orient,HideScrollBar,"LVScroll")
	Next
End Sub
'Set up the scroll listener and return a JavaObject for the scroll bar
Sub SetScrollListener(LV As ListView,Orient As String,HideScrollBar As Boolean,EventName As String) As JavaObject
	Dim LVJO As JavaObject = LV
	Dim L As JavaObject = LVJO.RunMethod("lookupAll",Array(".scroll-bar"))
	
	'L now contains an UnmodifiableListSet Object, so we can't iterate over it using For Each.  Use the standard Java Iterator
	Dim Iterator As JavaObject = L.RunMethod("iterator",Null)
    'Find the veritical scroll bar Node (The first one)
    Do While Iterator.RunMethod("hasNext",Null)
        Dim LVJO As JavaObject = Iterator.RunMethod("next",Null)
		If GetType(LVJO) = "com.sun.javafx.scene.control.skin.VirtualScrollBar" Then
			Dim ThisOrient As String = LVJO.RunMethod("getOrientation",Null)
			'Vertical scroll bar should be the first one, but best to check
			If ThisOrient = Orient Then Exit
		End If
    Loop

	'Set up the value change listener on the Scrollbar
	Dim e As Object = LVJO.CreateEventFromUI("javafx.beans.value.ChangeListener",EventName,Null)
	LVJO.RunMethodJO("valueProperty",Null).RunMethod("addListener",Array(e))
	
	If HideScrollBar Then
		'Hide the scroll bar for ListView 1 using CSS, Mouse activity in the area will still try to scroll (See LV1Scroll_event)
		LVJO.RunMethod("setStyle",Array("-fx-opacity: 0; -fx-padding: -7;"))
	End If
	
	Return LVJO
End Sub
Sub LVScroll_Event (MethodName As String,Args() As Object) As Object
	Dim Send As JavaObject = Sender
	For Each SB As JavaObject In mScrollBars
		'Stop ListView1 from manual scrolling by setting it to the position of ListView2
		If SB <> Send Then SB.RunMethod("setValue",Array(Send.RunMethod("getValue",Null)))
	Next
	Return Null
End Sub
'This Sub should be Called from the Module creating the control when a lists index is changed.
Sub SelectedIndexChanged(Index As Int,Send As ListView)
	'Update index of listviews except the one that created the event
	If mClicked.IsInitialized AND mClicked = Send Then
		For Each LV As ListView In mListViews
			If LV <> Send Then LV.SelectedIndex = Index
		Next
	End If
End Sub
'This Sub should be Called from the Module creating the control when a mouse mClicked event is fired on a list.
Sub MousePressed(Send As ListView)
	mClicked = Send
End Sub